PROGRAM SdelTree;  { (c) 30-05-96  par Sbastien HELLEU }

USES
  Crt,Dos;

CONST
  Size_buffer = 62000;

  Nb_fich_detruits : WORD = 0;
  Nb_repert        : WORD = 0;
  Gain_place       : LONGINT = 0;

VAR
  Rep_init,Rep_actuel : STRING;
  Buffer : ARRAY[1..Size_buffer] OF BYTE;

{================================= AIDE =====================================}

  PROCEDURE Aide;
    CONST
      Nom : ARRAY[1..44] OF WORD=
            (1079,884,897,988,1092,1066,897,897,416,416,520,1287,533,416,663,
             624,585,624,689,585,741,702,416,416,1456,1261,1482,416,1079,1690,
             1274,1261,1495,1508,1365,1313,1430,416,936,897,988,988,897,1105);
    VAR
      i : BYTE;
    BEGIN
      WriteLn;
      WriteLn('Dtruit les fichiers du rpertoire indiqu ainsi que tous ses sous-rpertoires.');
      WriteLn;
      FOR i:=1 TO 44 DO Write(Chr(Nom[i] DIV 13));
      WriteLn; WriteLn;
      WriteLn('  SDELTREE [nom_rpertoire]');
      WriteLn;
      WriteLn('    nom_rpertoire    nom du rpertoire  dtruire.');
      WriteLn;
      WriteLn('ATTENTION:  tous les sous-rpertoires seront dtruits.');
      WriteLn('            les fichiers ne seront pas rcuprables.');
      Halt(0)
    END;

{============================== LIGNE DE COMMANDE ===========================}

  PROCEDURE Examine_repertoire;
    BEGIN
      {$i-} ChDir(ParamStr(1)); {$i+}
      IF IOResult<>0 THEN
        BEGIN
          WriteLn; WriteLn('ERREUR: "',ParamStr(1),'" n''est pas un rpertoire.');
          Halt(1)
        END;
      ChDir(Rep_init);
      IF (Length(ParamStr(1))<=3) AND (Copy(ParamStr(1),2,1)=':') THEN
        BEGIN
          WriteLn; WriteLn('Par scurit, il est impossible de dtruire un disque complet.');
          Halt(1)
        END
    END;

  PROCEDURE Demande_confirmation;
    VAR
      k : CHAR;
    BEGIN
      WriteLn;
      Write('Destruction du rep. "',ParamStr(1),'" et de ses sous-rep. (O/N) ? ');
      REPEAT
        k:=UpCase(ReadKey);
        IF k=#0 THEN BEGIN k:=ReadKey; k:=#0 END
      UNTIL k IN ['O','N',#3,#27];
      IF k='O' THEN
        WriteLn('Oui')
      ELSE
        BEGIN WriteLn('Non'); Halt(1) END
    END;

{=================== DESTRUCTION DES REPERTOIRES ET FICHIERS ================}

  PROCEDURE Detruit_fichier(DirInfo : SEARCHREC);
    VAR
      x : BYTE;
      Avancement : LONGINT;
      Fichier : FILE;
      A_ecrire,Nb_ecrits : WORD;
      Date_Heure : DATETIME;
      Date_Heure_comp : LONGINT;
      Nom_renomme : STRING;
    BEGIN
      Assign(Fichier,DirInfo.Name);
      IF (DirInfo.Attr AND ReadOnly<>0) OR (DirInfo.Attr AND SysFile<>0) THEN
        SetFAttr(Fichier,DirInfo.Attr AND NOT ReadOnly AND NOT SysFile);
      GotoXY(1,WhereY); ClrEol;
      Write('Destruction du fichier ',Rep_actuel+DirInfo.Name,'... 0%');
      x:=WhereX-2;
      Assign(Fichier,DirInfo.Name);
      {$i-} ReWrite(Fichier,1); {$i+}
      IF IOresult<>0 THEN
        BEGIN
          WriteLn; WriteLn;
          WriteLn('ERREUR: effacement impossible du fichier '+DirInfo.Name);
          Halt(1)
        END;
      Avancement:=0;
      FillChar(Buffer,Size_buffer,0);
      REPEAT
        IF Avancement+Size_buffer>DirInfo.Size THEN
          A_ecrire:=DirInfo.Size-Avancement
        ELSE
          A_ecrire:=Size_buffer;
        {$i-} BlockWrite(Fichier,Buffer,A_ecrire,Nb_ecrits); {$i+}
        IF IOResult<>0 THEN
          BEGIN
            WriteLn; WriteLn;
            WriteLn('Erreur pendant la destruction du fichier.');
            Halt(1)
          END;
        Inc(Avancement,Nb_ecrits);
        GotoXY(x,WhereY); Write((Avancement*100) DIV DirInfo.Size,'%');
      UNTIL Avancement>=DirInfo.Size;
      Close(Fichier);
      {$i-} ReWrite(Fichier,1); {$i+}
      IF IOResult<>0 THEN
        BEGIN
          WriteLn; WriteLn;
          WriteLn('Erreur pendant la destruction du fichier.');
          Halt(1)
        END;
      WITH Date_Heure DO
        BEGIN Year:=1980; Month:=0; Day:=0; Hour:=0; Min:=0; Sec:=0 END;
      PackTime(Date_Heure,Date_Heure_comp);
      SetFTime(Fichier,Date_Heure_comp);
      Close(Fichier);
      Nom_renomme:='A';
      REPEAT
        Rename(Fichier,Nom_renomme);
        Nom_renomme:=Chr(Ord(Nom_renomme[1])+1)
      UNTIL IOResult=0;
      {$i-} Erase(Fichier); {$i+}
      IF IOResult<>0 THEN
        BEGIN
          WriteLn; WriteLn;
          WriteLn('Erreur pendant l''effacement du fichier.');
          Halt(1)
        END;
      Inc(Nb_fich_detruits);
      Inc(Gain_place,DirInfo.Size)
    END;

  PROCEDURE Detruit(Repertoire : STRING);
    VAR
      DirInfo : SEARCHREC;
    BEGIN
      ChDir(Repertoire);
      GetDir(0,Rep_actuel);
      IF Copy(Rep_actuel,Length(Rep_actuel),1)<>'\' THEN
        Rep_actuel:=Rep_actuel+'\';
      FindFirst('*.*',AnyFile-Directory-VolumeID,DirInfo);
      WHILE DosError=0 DO
        BEGIN
          Detruit_fichier(DirInfo);
          FindNext(DirInfo)
        END;
      FindFirst('*.*',Directory,DirInfo);
      WHILE DosError=0 DO
        BEGIN
          IF (DirInfo.Name<>'.') AND (DirInfo.Name<>'..')
            AND (DirInfo.Attr AND Directory<>0) THEN
            BEGIN
              Detruit(DirInfo.Name);
              Inc(Nb_repert);
              {$i-} RmDir(DirInfo.Name); {$i+}
              IF IOResult<>0 THEN
                BEGIN
                  WriteLn; WriteLn('ERREUR GRAVE: effacement impossible du rpertoire '+DirInfo.Name);
                  Halt(1)
                END
            END;
          FindNext(DirInfo)
        END;
      {$i-} ChDir('..'); {$i+}
      IF IOResult<>0 THEN Exit
    END;

  PROCEDURE Message_fin;
    VAR
      i : BYTE;
      Chaine,Chaine2 : STRING;
    BEGIN
      Write(Nb_fich_detruits,' fichier');
      IF Nb_fich_detruits>1 THEN Write('s');
      Write(' dtruit'); IF Nb_fich_detruits>1 THEN Write('s');
      Write(' dans ',Nb_repert+1,' rpertoire');
      IF Nb_repert+1>1 THEN Write('s');
      Write(', ');
      Str(Gain_place,Chaine); Chaine2:=Chaine;
      FOR i:=Length(Chaine) DOWNTO 1 DO
        IF ((Length(Chaine)-i+1) MOD 3=0) AND (i>1) THEN Insert(' ',Chaine2,i);
      Write(Chaine2,' octet'); IF Gain_place>1 THEN Write('s');
      Write(' gagn'); IF Gain_place>1 THEN Write('s');
      WriteLn('.')
    END;

BEGIN
  CheckBreak:=False;
  IF (ParamCount<>1) OR (ParamStr(1)='?') OR (ParamStr(1)='/?') THEN Aide;
  GetDir(0,Rep_init);
  Examine_repertoire;
  Demande_confirmation;
  WriteLn;
  Detruit(ParamStr(1));
  RmDir(ParamStr(1));
  GotoXY(1,WhereY); ClrEol;
  ChDir(Rep_init);
  Message_fin;
END.